/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Noah Zarro
 *      Theo von Arx
 *   Co-authors:
 *      
 *
 */

/**
    @file SOBGumbaBoss.h
    @brief Declaration of the SOBGumbaBoss class. GumbaBosss are the enemie mushrooms - pretty sure it's written Goomba but, naaah
    @ingroup SOB
*/

#ifndef _SOBGumbaBoss_H__
#define _SOBGumbaBoss_H__

#include "superorxobros/SOBPrereqs.h"
#include "worldentities/MovableEntity.h"


namespace orxonox
{
    class _SOBExport SOBGumbaBoss : public SOBGumba
    {
        public:
            SOBGumbaBoss(Context* context);
            virtual  bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;
            virtual void tick(float dt) override;

            void spawnGumba();


        protected:
            float gumbaTime_;
            float gumbaMaxTime_;
            int maxGumbas;

           
    };
}

#endif /* _SOBGumbaBoss_H__ */
